##
##  moarvm.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2024 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg  2024.10
%define       V_dist  2024.10

#   package information
Name:         moarvm
Summary:      Virtual Machine for NQP and Rakudo Perl 6
URL:          http://moarvm.com/
Vendor:       MoarVM Team
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      Artistic
Version:      %{V_opkg}
Release:      20241025

#   list of sources
Source0:      http://moarvm.com/releases/MoarVM-%{V_dist}.tar.gz

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20160101, perl, gcc
PreReq:       OpenPKG, openpkg >= 20160101
AutoReq:      no
AutoReqProv:  no

%description
    MoarVM (short for "Metamodel On A Runtime Virtual Machine") is a
    runtime built for the model object system. It is primarily aimed
    at running NQP and Rakudo Perl 6, but should be able to serve as a
    backend for any compilers built using the NQP compiler toolchain.

%track
    prog moarvm = {
        version   = %{V_dist}
        url       = https://github.com/MoarVM/MoarVM/releases
        regex     = (\d{4}\.\d{2}(?:\.\d+)?)\.tar\.gz
    }

%prep
    %setup -q -n MoarVM-%{V_dist}

%build
    export CC="%{l_cc}"
    export CFLAGS="%{l_cflags}"
    %{l_prefix}/bin/perl Configure.pl \
        --prefix=%{l_prefix} \
        --compiler=gcc \
        --cc="%{l_cc}"
    %{l_make} %{l_mflags -O}

%install
    %{l_make} %{l_mflags} install DESTDIR=$RPM_BUILD_ROOT
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/share/doc
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

